# 股票订阅
## OpenD
> FutuOpenD.xml

填入账号密码，并且将红框内的端口号记住，需要填入订阅程序的参数中
![OpenD配置文件](https://upload-images.jianshu.io/upload_images/10171495-df2b2005d8ca4b99.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/800)

## 数据获取程序
> data_acquisition.py

只需要调用quote_test()即可得到订阅
```
# -*- coding: utf-8 -*-
from futuquant import *

import data_strategy

class TickerTest(TickerHandlerBase):
    """ 获取逐笔推送数据 """
    def on_recv_rsp(self, rsp_pb):
        """数据响应回调函数"""
        ret_code, content = super(TickerTest, self).parse_rsp_pb(rsp_pb)
        if ret_code != RET_OK:
            print("* TickerTest: error, msg: %s" % content)
            return RET_ERROR, content
        print("* TickerTest\n", content)

        # 下面这一行是数据处理监测逻辑，只订阅逐笔可以去掉
        # data_strategy.detect_and_send(content)

        return RET_OK, content

def quote_test(code_list, host, port):
    quote_ctx = OpenQuoteContext(host, port)
    print("Server lim.app:%s connected..." % port)
    # 设置异步回调接口
    quote_ctx.set_handler(TickerTest())
    quote_ctx.start()

    quote_ctx.subscribe(code_list, SubType.TICKER)
    print(quote_ctx.query_subscription())
```
## 主程序
> main.py

填写OpenD端口号和股票列表
```
from futuquant import *
from data_acquisition import *
host='127.0.0.1'
port=11111  # 此处填写Opend端口号
subtype_list = [SubType.QUOTE, SubType.ORDER_BOOK, SubType.TICKER, SubType.K_DAY, SubType.RT_DATA, SubType.BROKER]
big_sub_codes = ['HK.02318', 'HK.02828', 'HK.00939', 'HK.01093', 'HK.01299', 'HK.00175',
                 'HK.01299', 'HK.01833', 'HK.00005', 'HK.00883', 'HK.00388', 'HK.01398',
                 'HK.01114', 'HK.02800', 'HK.02018', 'HK.03988', 'HK.00386', 'HK.01211',
                 'HK.00857', 'HK.01177',  'HK.02601', 'HK.02628']

quote_test(big_sub_codes, host, port)
```

## 运行
运行main.py即可订阅逐笔，运行成功如下图

![成功运行图示](https://upload-images.jianshu.io/upload_images/10171495-57723c0fbdb9d067.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)